#include "glliste.h"

GLListe *GLListe::_singleton = NULL; // Pas d'instance pour le moment ...

GLListe::GLListe()
{
	GLListeNbElem = 0;
	GLMemListe = NULL;
}

GLListe::~GLListe()
{
	ViderListe();
}

// On efface tout !
void GLListe::ViderListe()
{
	if (GLMemListe != NULL)
		delete [] GLMemListe;
	GLListeNbElem = 0;
}

// Ajoute un lment dans la liste ( la fin de celle-ci)
void GLListe::AjouteListe (int hwnd, long instance)
{
	int iPosition;
    if (GLMemListe == NULL)
    {
      GLMemListe = new MEMLISTE [1];
      iPosition = 0;
	  GLListeNbElem = 1;
    }
    else
    {
		iPosition = ChercheListe (hwnd);
		if (iPosition >= GLListeNbElem)
		{
		  LPMEMLISTE GLMemListeNew = new MEMLISTE [GLListeNbElem + 1];
		  memcpy (GLMemListeNew, GLMemListe, sizeof (stmemliste) * GLListeNbElem);
		  delete [] GLMemListe;
		  GLMemListe = GLMemListeNew;
		  iPosition = GLListeNbElem;
		  GLListeNbElem++;
		}
    }
    GLMemListe[iPosition].hwnd = hwnd;
    GLMemListe[iPosition].instance = instance;
}

// Retire un lment de la liste
void GLListe::RetireListe(int hwnd)
{
	if (GLMemListe != NULL)
	{
		int iPosition;
		iPosition = ChercheListe (hwnd);

		if (iPosition < GLListeNbElem)
		{
		  LPMEMLISTE GLMemListeNew = new MEMLISTE [GLListeNbElem - 1];
		  if (iPosition > 0)
			memcpy (GLMemListeNew, GLMemListe, sizeof (stmemliste) * (iPosition - 1));
		  if (iPosition != GLListeNbElem - 1)
			memcpy ((void*)&GLMemListeNew[iPosition], (void*)&GLMemListe[iPosition + 1], sizeof (stmemliste) * (GLListeNbElem - iPosition));
		}
		GLListeNbElem--;

	}
}

// Retourne la position dans la liste d'un handle d'une frame
// Sachant que position va de 0 à nb element - 1
// Si la valeur en sortie est egal à nbelement, alors position non trouvé !
long GLListe::ChercheListe (int hwnd)
{
    int iCpt=0;
    bool bTrv = false;
    
    while (iCpt < GLListeNbElem && bTrv == false)
    {
		if (GLMemListe[iCpt].hwnd == hwnd)
		{
		    bTrv = true;
		}
		else
			iCpt++;
    }
    return iCpt;
}

// Indique le nombre total d'lments dans la liste
long GLListe::NbElements()
{
	return GLListeNbElem;
}

bool GLListe::LireElement (int hwnd, long &instance)
{
	int iPosition = ChercheListe (hwnd);
	if (iPosition == GLListeNbElem)
	{
		return false;
	}
	else
	{
		instance = GLMemListe[iPosition].instance;
		return true;
	}
}